

   MEMBER('PEOPLE.clw')                                    ! This is a MEMBER module


   INCLUDE('ABBROWSE.INC'),ONCE
   INCLUDE('ABPOPUP.INC'),ONCE
   INCLUDE('ABRESIZE.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('PEOPL002.INC'),ONCE        !Local module procedure declarations
                       INCLUDE('PEOPL001.INC'),ONCE        !Req'd for module callout resolution
                     END


BrowsepeopleForm PROCEDURE                                 ! Generated from procedure template - Window

CurrentTab           STRING(80)                            !
FilesOpened          BYTE                                  !
BRW1::View:Browse    VIEW(people)
                       PROJECT(PEO:Id)
                       PROJECT(PEO:FirstName)
                       PROJECT(PEO:LastName)
                       PROJECT(PEO:Gender)
                       PROJECT(PEO:Born)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
PEO:Id                 LIKE(PEO:Id)                   !List box control field - type derived from field
PEO:FirstName          LIKE(PEO:FirstName)            !List box control field - type derived from field
PEO:LastName           LIKE(PEO:LastName)             !List box control field - type derived from field
PEO:Gender             LIKE(PEO:Gender)               !List box control field - type derived from field
PEO:Born               LIKE(PEO:Born)                 !List box control field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Browse the people File'),AT(,,381,265),FONT('MS Sans Serif',8,COLOR:Black,),CENTER,IMM,HLP('Browsepeople'),SYSTEM,GRAY,RESIZE,MDI
                       SHEET,AT(5,0,357,234),USE(?CurrentTab)
                         TAB('by &PEOPLE Id'),USE(?Tab:2)
                         END
                         TAB('by &LastName'),USE(?Tab:3)
                         END
                       END
                       LIST,AT(8,20,340,209),USE(?Browse:1),IMM,HVSCROLL,MSG('Browsing Records'),FORMAT('44L(2)|M~Id~@S10@71L(2)|M~First Name~@S30@87L(2)|M~Last Name~@S30@28L(11)|M~Gend' &|
         'er~L(2)@S1@44L(11)|M~Born~L(2)@d8@'),FROM(Queue:Browse:1)
                       BUTTON('&Select'),AT(86,246,47,14),USE(?Select),FLAT,LEFT,ICON('WASelect.ico')
                       BUTTON('&Insert'),AT(141,246,41,14),USE(?Insert:2),FLAT,LEFT,ICON('WAINSERT.ICO')
                       BUTTON('&Change'),AT(191,246,51,14),USE(?Change:2),FLAT,LEFT,ICON('WACHANGE.ICO'),DEFAULT
                       BUTTON('&Delete'),AT(249,246,45,14),USE(?Delete:2),FLAT,LEFT,ICON('WADELETE.ICO')
                       BUTTON('&Print'),AT(5,247,39,13),USE(?Print),FLAT,LEFT,ICON(ICON:Print1)
                       BUTTON('Close'),AT(330,247,45,14),USE(?Close),FLAT,LEFT,ICON('WACLOSE.ICO')
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Kill                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED ! Method added to host embed code
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)                    ! Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Fetch                  PROCEDURE(BYTE Direction),DERIVED   ! Method added to host embed code
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM) ! Method added to host embed code
ResetSort              PROCEDURE(BYTE Force),BYTE,PROC,DERIVED ! Method added to host embed code
                     END

BRW1::Sort0:Locator  StepLocatorClass                      ! Default Locator
BRW1::Sort2:Locator  FilterLocatorClass                    ! Conditional Locator - CHOICE(?CurrentTab) = 2
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False) ! Method added to host embed code
                     END


  CODE
? DEBUGHOOK(people:Record)
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('BrowsepeopleForm')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Browse:1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  Relate:people.Open                                       ! File people used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:people,SELF) ! Initialize the browse manager
  SELF.Open(QuickWindow)                                   ! Open window
  ?Browse:1{Prop:LineHeight} = 0
  Do DefineListboxStyle
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  BRW1.Q &= Queue:Browse:1
  BRW1.FileLoaded = 1                                      ! This is a 'file loaded' browse
  BRW1.AddSortOrder(,PEO:KeyLastName)                      ! Add the sort order for PEO:KeyLastName for sort order 1
  BRW1.AddLocator(BRW1::Sort2:Locator)                     ! Browse has a locator for sort order 1
  BRW1::Sort2:Locator.Init(,PEO:LastName,1,BRW1)           ! Initialize the browse locator using  using key: PEO:KeyLastName , PEO:LastName
  BRW1::Sort2:Locator.FloatRight = 1
  BRW1.AddSortOrder(,PEO:KeyId)                            ! Add the sort order for PEO:KeyId for sort order 2
  BRW1.AddLocator(BRW1::Sort0:Locator)                     ! Browse has a locator for sort order 2
  BRW1::Sort0:Locator.Init(,PEO:Id,1,BRW1)                 ! Initialize the browse locator using  using key: PEO:KeyId , PEO:Id
  BRW1.AddField(PEO:Id,BRW1.Q.PEO:Id)                      ! Field PEO:Id is a hot field or requires assignment from browse
  BRW1.AddField(PEO:FirstName,BRW1.Q.PEO:FirstName)        ! Field PEO:FirstName is a hot field or requires assignment from browse
  BRW1.AddField(PEO:LastName,BRW1.Q.PEO:LastName)          ! Field PEO:LastName is a hot field or requires assignment from browse
  BRW1.AddField(PEO:Gender,BRW1.Q.PEO:Gender)              ! Field PEO:Gender is a hot field or requires assignment from browse
  BRW1.AddField(PEO:Born,BRW1.Q.PEO:Born)                  ! Field PEO:Born is a hot field or requires assignment from browse
  BRW1.AskProcedure = 1
  BRW1.AddToolbarTarget(Toolbar)                           ! Browse accepts toolbar control
  BRW1.PrintProcedure = 2
  BRW1.PrintControl = ?Print
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:people.Close
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    EXECUTE Number
      Updatepeople
      PrintPEO:KeyLastName
    END
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


BRW1.Fetch PROCEDURE(BYTE Direction)

GreenBarIndex   LONG
  CODE
  PARENT.Fetch(Direction)


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  SELF.SelectControl = ?Select
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  IF WM.Request <> ViewRecord                              ! If called for anything other than ViewMode, make the insert, change & delete controls available
    SELF.InsertControl=?Insert:2
    SELF.ChangeControl=?Change:2
    SELF.DeleteControl=?Delete:2
  END


BRW1.ResetSort PROCEDURE(BYTE Force)

ReturnValue          BYTE,AUTO

  CODE
  IF CHOICE(?CurrentTab) = 2
    RETURN SELF.SetSort(1,Force)
  ELSE
    RETURN SELF.SetSort(2,Force)
  END
  ReturnValue = PARENT.ResetSort(Force)
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.DeferMoves=False
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

