

   MEMBER('PEOPLE.clw')                                    ! This is a MEMBER module


   INCLUDE('ABRESIZE.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABUTIL.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('PEOPL004.INC'),ONCE        !Local module procedure declarations
                       INCLUDE('PEOPL002.INC'),ONCE        !Req'd for module callout resolution
                     END


UpdateSiteUse PROCEDURE                                    ! Generated from procedure template - Window

CurrentTab           STRING(80)                            !
ActionMessage        CSTRING(40)                           !
Loc:LastName         CSTRING(31)                           !
Loc:FirstName        CSTRING(26)                           !
History::STU:Record  LIKE(STU:RECORD),THREAD
QuickWindow          WINDOW('Form SiteUse'),AT(,,273,121),FONT('MS Sans Serif',8,,FONT:regular),CENTER,IMM,HLP('UpdateSiteUse'),SYSTEM,GRAY,RESIZE,MDI
                       PROMPT('recd nbr:'),AT(181,3),USE(?STU:recd_nbr:Prompt),TRN
                       ENTRY(@n012),AT(213,3,57,10),USE(STU:recd_nbr),SKIP,RIGHT(1),COLOR(COLOR:Silver),READONLY
                       ENTRY(@s25),AT(167,33,99,10),USE(Loc:FirstName),SKIP,COLOR(0FFFF80H),READONLY
                       PROMPT('Person:'),AT(6,32),USE(?Loc:LastName:Prompt)
                       ENTRY(@s30),AT(60,33,103,10),USE(Loc:LastName),SKIP,COLOR(0FFFF80H),READONLY
                       PROMPT('Person ID:'),AT(7,4),USE(?STU:PersonID:Prompt),TRN
                       ENTRY(@n020),AT(61,4,84,10),USE(STU:PersonID),RIGHT(1),COLOR(0BBF3FBH)
                       PROMPT('Date Used:'),AT(7,50),USE(?STU:DateUsed:Prompt),TRN
                       ENTRY(@d3),AT(61,50,69,10),USE(STU:DateUsed),RIGHT(1)
                       BUTTON,AT(141,48,17,12),USE(?Calendar),ICON('cal.ico')
                       PROMPT('Time Start:'),AT(7,64),USE(?STU:TimeStart:Prompt),TRN
                       ENTRY(@t3),AT(61,64,70,10),USE(STU:TimeStart),RIGHT(1)
                       PROMPT('Activity:'),AT(7,79),USE(?STU:Activity:Prompt),TRN
                       ENTRY(@s50),AT(61,79,204,10),USE(STU:Activity)
                       BUTTON('&OK'),AT(219,97,50,17),USE(?OK),FLAT,LEFT,MSG('Accept data and close the window'),TIP('Accept data and close the window'),ICON('WAOK.ICO'),DEFAULT
                       BUTTON('&Cancel'),AT(165,97,50,17),USE(?Cancel),FLAT,LEFT,MSG('Cancel operation'),TIP('Cancel operation'),ICON('WACANCEL.ICO')
                       BUTTON('&Help'),AT(9,97,50,17),USE(?Help),FLAT,LEFT,MSG('See Help Window'),TIP('See Help Window'),ICON('WAHELP.ICO'),STD(STD:Help)
                     END

ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED                 ! Method added to host embed code
Init                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Kill                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
PrimeFields            PROCEDURE(),PROC,DERIVED            ! Method added to host embed code
PrimeUpdate            PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Run                    PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED ! Method added to host embed code
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
TakeSelected           PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
                     END

Toolbar              ToolbarClass
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False) ! Method added to host embed code
                     END

Calendar7            CalendarClass
CurCtrlFeq          LONG
FieldColorQueue     QUEUE
Feq                   LONG
OldColor              LONG
                    END

  CODE
? DEBUGHOOK(people:Record)
? DEBUGHOOK(SiteUse:Record)
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Ask PROCEDURE

  CODE
  CASE SELF.Request                                        ! Configure the action message text
  OF ViewRecord
    ActionMessage = 'View Record'
  OF InsertRecord
    ActionMessage = 'Record Will Be Added'
  OF ChangeRecord
    ActionMessage = 'Record Will Be Changed'
  END
  QuickWindow{Prop:Text} = ActionMessage                   ! Display status message in title bar
  PARENT.Ask


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('UpdateSiteUse')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?STU:recd_nbr:Prompt
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  IF SELF.Request ~= InsertRecord THEN SELF.FirstField = ?STU:DateUsed:Prompt.
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.HistoryKey = CtrlH
  SELF.AddHistoryFile(STU:Record,History::STU:Record)
  SELF.AddHistoryField(?STU:recd_nbr,1)
  SELF.AddHistoryField(?STU:PersonID,2)
  SELF.AddHistoryField(?STU:DateUsed,3)
  SELF.AddHistoryField(?STU:TimeStart,4)
  SELF.AddHistoryField(?STU:Activity,5)
  SELF.AddUpdateFile(Access:SiteUse)
  SELF.AddItem(?Cancel,RequestCancelled)                   ! Add the cancel control to the window manager
  Relate:people.Open                                       ! File people used by this procedure, so make sure it's RelationManager is open
  Relate:SiteUse.Open                                      ! File SiteUse used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  SELF.Primary &= Relate:SiteUse
  IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing ! Setup actions for ViewOnly Mode
    SELF.InsertAction = Insert:None
    SELF.DeleteAction = Delete:None
    SELF.ChangeAction = Change:None
    SELF.CancelAction = Cancel:Cancel
    SELF.OkControl = 0
  ELSE
    SELF.ChangeAction = Change:Caller                      ! Changes allowed
    SELF.CancelAction = Cancel:Cancel+Cancel:Query         ! Confirm cancel
    SELF.OkControl = ?OK
    IF SELF.PrimeUpdate() THEN RETURN Level:Notify.
  END
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  IF SELF.Request = ViewRecord                             ! Configure controls for View Only mode
    ?STU:recd_nbr{PROP:ReadOnly} = True
    ?Loc:FirstName{PROP:ReadOnly} = True
    ?Loc:LastName{PROP:ReadOnly} = True
    ?STU:PersonID{PROP:ReadOnly} = True
    ?STU:DateUsed{PROP:ReadOnly} = True
    DISABLE(?Calendar)
    ?STU:TimeStart{PROP:ReadOnly} = True
    ?STU:Activity{PROP:ReadOnly} = True
  END
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:people.Close
    Relate:SiteUse.Close
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.PrimeFields PROCEDURE

  CODE
  PARENT.PrimeFields
  STU:Activity = 'General'
  STU:TimeStart= 2700001


ThisWindow.PrimeUpdate PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.PrimeUpdate()
  PEO:Id=STU:PersonID
  Case Access:People.TryFetch(PEO:KeyId)
  OF Level:Benign
     Loc:LastName=PEO:LastName
     Loc:FirstName=PEO:FirstName
  ELSE
     Loc:LastName = 'Not Found'
     Loc:FirstName= ''
  END
  RETURN ReturnValue


ThisWindow.Run PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run()
  IF SELF.Request = ViewRecord                             ! In View Only mode always signal RequestCancelled
    ReturnValue = RequestCancelled
  END
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    BrowsepeopleForm
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?Calendar
      ThisWindow.Update
      Calendar7.SelectOnClose = True
      Calendar7.Ask('Select Start Date',STU:DateUsed)
      IF Calendar7.Response = RequestCompleted THEN
      STU:DateUsed=Calendar7.SelectedDate
      DISPLAY(?STU:DateUsed)
      END
      ThisWindow.Reset(True)
    OF ?OK
      ThisWindow.Update
      IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing THEN
         POST(EVENT:CloseWindow)
      END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeSelected PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all Selected events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeSelected()
    CASE FIELD()
    OF ?STU:PersonID
      PEO:Id = STU:PersonID
      IF Access:people.TryFetch(PEO:KeyId)
        IF SELF.Run(1,SelectRecord) = RequestCompleted
          STU:PersonID = PEO:Id
          Loc:LastName = PEO:LastName
          Loc:FirstName = PEO:FirstName
      ELSE
          CLEAR(Loc:LastName)
          CLEAR(Loc:FirstName)
        END
      END
      ThisWindow.Reset
       SELECT(?STU:DateUsed)
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.DeferMoves=False
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

