   PROGRAM



   INCLUDE('ABERROR.INC'),ONCE
   INCLUDE('ABFILE.INC'),ONCE
   INCLUDE('ABUTIL.INC'),ONCE
   INCLUDE('ERRORS.CLW'),ONCE
   INCLUDE('KEYCODES.CLW'),ONCE

   MAP
     MODULE('Windows API')
SystemParametersInfo PROCEDURE (LONG uAction, LONG uParam, *? lpvParam, LONG fuWinIni),LONG,RAW,PROC,PASCAL,DLL(TRUE),NAME('SystemParametersInfoA')
     END
     MODULE('PEOPLBC.CLW')
DctInit     PROCEDURE                                      ! Initializes the dictionary definition module
DctKill     PROCEDURE                                      ! Kills the dictionary definition module
     END
!--- Application Global and Exported Procedure Definitions --------------------------------------------
     MODULE('PEOPL001.CLW')
Main                   PROCEDURE   !Example EIP Application
     END
   END

Glo:CurrentDate      LONG
Glo:DateString       CSTRING(31)
Glo:FilterStrg       CSTRING(251)
SilentRunning        BYTE(0)                               ! Set true when application is running in 'silent mode'

people               FILE,DRIVER('TOPSPEED'),PRE(PEO),CREATE,BINDABLE,THREAD
KeyId                    KEY(PEO:Id),NOCASE,OPT
KeyLastName              KEY(PEO:LastName),DUP,NOCASE
Record                   RECORD,PRE()
Id                          LONG
FirstName                   STRING(30)
LastName                    STRING(30)
Gender                      STRING(1)
Born                        DATE
                         END
                     END                       

SiteUse              FILE,DRIVER('TOPSPEED'),PRE(STU),CREATE,BINDABLE,THREAD
k_Recd_nbr               KEY(STU:recd_nbr),NOCASE,OPT,PRIMARY
k_Date                   KEY(STU:DateUsed,STU:TimeStart),DUP,NOCASE,OPT
k_PersonID               KEY(STU:PersonID),DUP,NOCASE,OPT
Record                   RECORD,PRE()
recd_nbr                    REAL
PersonID                    LONG
DateUsed                    LONG
TimeStart                   LONG
Activity                    CSTRING(51)
                         END
                     END                       


Access:people        &FileManager,THREAD                   ! FileManager for people
Relate:people        &RelationManager,THREAD               ! RelationManager for people
Access:SiteUse       &FileManager,THREAD                   ! FileManager for SiteUse
Relate:SiteUse       &RelationManager,THREAD               ! RelationManager for SiteUse

GlobalErrorStatus    ErrorStatusClass,THREAD
GlobalErrors         ErrorClass                            ! Global error manager
INIMgr               INIClass                              ! Global non-volatile storage manager
GlobalRequest        BYTE(0),THREAD                        ! Set when a browse calls a form, to let it know action to perform
GlobalResponse       BYTE(0),THREAD                        ! Set to the response from the form
VCRRequest           LONG(0),THREAD                        ! Set to the request from the VCR buttons

Dictionary           CLASS,THREAD
Construct              PROCEDURE
Destruct               PROCEDURE
                     END

lCurrentFDSetting    LONG                                  ! Used by window frame dragging
lAdjFDSetting        LONG                                  ! ditto

  CODE
  GlobalErrors.Init(GlobalErrorStatus)
  INIMgr.Init('.\PEOPLE.INI', NVD_INI)                     ! Configure INIManager to use INI file
  DctInit
  SystemParametersInfo (38, 0, lCurrentFDSetting, 0)       ! Configure frame dragging
  IF lCurrentFDSetting = 1
    SystemParametersInfo (37, 0, lAdjFDSetting, 3)
  END
  Main
  INIMgr.Update
  IF lCurrentFDSetting = 1
    SystemParametersInfo (37, 1, lAdjFDSetting, 3)
  END
  INIMgr.Kill                                              ! Destroy INI manager


Dictionary.Construct PROCEDURE

  CODE
  IF THREAD()<>1
     DctInit()
  END


Dictionary.Destruct PROCEDURE

  CODE
  DctKill()

